<template>
  <single-pane class="logchain-item" v-if="startPoint && endPoint">
    <Preloader v-if="isLoading" />
    <template v-slot:header>
      <div class="logchain-item__header">
        <router-link tag="span" :to="backLink">
          <i class="icon chevron-left"></i>
          Браузер логцепочек
        </router-link>
        <div class="logchain-item__summary">
          <p v-if="logchain.mainData.number">
            {{ logchain.mainData.number }}
          </p>
          <template v-if="startPoint.address.label && endPoint.address.label">
            <div class="logchain-item__summary-route">
              <div v-for="point in logchain.points" :key="point.locationUuid">
                <template v-if="point.resourceClassUuid">
                  <i
                    :class="[
                      'icon',
                      $options.iconsMap[point.resourceClassUuid],
                      point.isMain ? 'main' : '',
                    ]"
                  ></i>
                </template>
                {{ point.address.label }}
              </div>
            </div>
            <!-- {{ startPoint.address.label }} → {{ endPoint.address.label }} -->
          </template>
          <!-- <span v-if="!isPublished">Черновик</span> -->
          <span v-if="isPublished">Опубликована</span>
        </div>
      </div>
    </template>
    <div
      class="logchain-item__card"
      v-if="startPoint.address.label && endPoint.address.label"
    >
      <logchain-route-card
        :startPoint="startPoint"
        :endPoint="endPoint"
        :inBetweenPoints="inBetweenPoints"
        :servicePoints="servicePoints"
        :serviceCategoryIcon="serviceCategoryIcon"
      />
    </div>
    <div class="logchain-item__tabs">
      <ObTabs
        v-model="currentTab"
        :items="tabsItems"
        :no-border="true"
        value-exp="uuid"
        data-qa="logchainItemTabs"
      />
    </div>
    <div class="logchain-item__constructor-wrapper">
      <div
        class="logchain-item-constructor"
        v-if="currentTab.uuid === 'locations'"
      >
        <div class="logchain-item-constructor__item">
          <h2 class="logchain-title">
            {{ startPoint.address.label ? startPoint.address.label : "Откуда" }}
          </h2>
          <ObAddressInput
            title="Первая точка маршрута"
            :locationsTypes="locationsTypes"
            :address="startPoint.address.label"
            :prefixIcon="startPoint.address.icon || ''"
            :disabled="isPublished"
            :showMap="false"
            isLocationsOnly
            customIcon="map"
            customAction
            placeholder="Выберите локацию или укажите на карте"
            required
            data-qa="addressFrom"
            @input="setAddressFrom"
            @customAction="onOpenMapModal(startPoint, 'from')"
          />
          <div class="logchain-item-constructor__item-services">
            <ob-select
              label="Перечень услуг"
              placeholder="Выберите из списка"
              :items="pointServices"
              :value="startPoint.servicesOnPoint.map((item) => item.uuid)"
              displayExp="title"
              valueExp="uuid"
              isStandart
              popperClass="point-services-wrapper"
              :is-tagbox="true"
              :is-multiselect="true"
              :isDropdown="true"
              :disabled="isPublished"
              icon="plus"
              @input="onSubmitPointServices($event, 'start')"
            />
          </div>
        </div>

        <div
          v-if="startPoint.address.label && !endPoint.address.label"
          class="add-location"
        >
          <i class="icon info"></i>
          Добавьте локацию Куда
        </div>

        <template
          v-if="
            startPoint.address.label &&
              endPoint.address.label &&
              inBetweenPoints.length
          "
        >
          <div
            class="location-item-constructor__item"
            v-for="(point, index) in inBetweenPoints"
            :key="point.uuid"
          >
            <location-shoulder
              :isPublished="isPublished"
              :point="{
                from:
                  index > 0
                    ? inBetweenPoints[index - 1].address.label
                    : startPoint.address.label,
                to: endPoint.address.label,
                ...point,
              }"
              :prevOrdinal="
                index !== 0
                  ? inBetweenPoints[index - 1].ordinal
                  : startPoint.ordinal
              "
              :logchainModality="logchain.mainData.resourceClassUuid"
              :isMultistop="logchain.mainData.isMultistop"
              @onAddServices="addServices"
              @onAddPoint="addPoint"
              @onMakeActivePoint="makeActivePoint"
            />
            <div class="logchain-item-constructor__item">
              <h2
                :class="[
                  'logchain-title',
                  point.locationTitle === 'Новая локация'
                    ? 'logchain-title--new'
                    : '',
                ]"
              >
                {{ point.locationTitle ? point.locationTitle : "Откуда" }}
                <i class="icon close" @click="removePoint(point.ordinal)" />
              </h2>
              <ObAddressInput
                title="Локация"
                :locationsTypes="locationsTypes"
                :address="point.address.label"
                :prefixIcon="point.address.icon || ''"
                :disabled="isPublished"
                :showMap="false"
                isLocationsOnly
                customIcon="map"
                customAction
                placeholder="Выберите локацию или укажите на карте"
                data-qa="addressFrom"
                @input="setInBetweenAddress($event, point)"
                @customAction="onOpenMapModal(point, '')"
              />
              <div class="logchain-item-constructor__item-services">
                <ob-select
                  label="Перечень услуг"
                  placeholder="Выберите из списка"
                  :items="pointServices"
                  :value="point.servicesOnPoint.map((item) => item.uuid)"
                  displayExp="title"
                  valueExp="uuid"
                  isStandart
                  popperClass="point-services-wrapper"
                  :is-tagbox="true"
                  :is-multiselect="true"
                  :isDropdown="true"
                  :disabled="isPublished"
                  icon="plus"
                  @input="onSubmitPointServices($event, point)"
                />
              </div>
            </div>
          </div>
        </template>

        <template v-if="startPoint.address.label && endPoint.address.label">
          <location-shoulder
            :isPublished="isPublished"
            :point="{
              from: inBetweenPoints.length
                ? inBetweenPoints[inBetweenPoints.length - 1].address.label
                : startPoint.address.label,
              ...endPoint,
            }"
            :logchainModality="logchain.mainData.resourceClassUuid"
            :prevOrdinal="startPoint.ordinal"
            :isMultistop="logchain.mainData.isMultistop"
            @onAddServices="addServices"
            @onAddPoint="
              addPoint(
                inBetweenPoints.length
                  ? inBetweenPoints[inBetweenPoints.length - 1].ordinal
                  : startPoint.ordinal
              )
            "
            @onMakeActivePoint="makeActivePoint"
          />
        </template>

        <div class="logchain-item-constructor__item">
          <h2 :class="['logchain-title', endPoint.isMain]">
            {{ endPoint.address.label ? endPoint.address.label : "Куда" }}
          </h2>
          <ObAddressInput
            title="Последняя точка маршрута"
            :locationsTypes="locationsTypes"
            :address="endPoint.address.label"
            :prefixIcon="endPoint.address.icon || ''"
            :disabled="isPublished"
            :showMap="false"
            isLocationsOnly
            customIcon="map"
            customAction
            placeholder="Выберите локацию или укажите на карте"
            required
            data-qa="addressTo"
            @input="setAddressTo"
            @customAction="onOpenMapModal(endPoint, 'to')"
          />
          <div class="logchain-item-constructor__item-services">
            <ob-select
              label="Перечень услуг"
              placeholder="Выберите из списка"
              :items="pointServices"
              :value="endPoint.servicesOnPoint.map((item) => item.uuid)"
              displayExp="title"
              valueExp="uuid"
              isStandart
              popperClass="point-services-wrapper"
              :is-tagbox="true"
              :is-multiselect="true"
              :isDropdown="true"
              :disabled="isPublished"
              icon="plus"
              @input="onSubmitPointServices($event, 'end')"
            />
          </div>
        </div>
      </div>
      <div class="logchain-item-services" v-if="currentTab.uuid === 'services'">
        <ob-select
          label="Перечень услуг"
          placeholder="Выберите из списка"
          v-model="logchainActiveServices"
          :items="logchainServices"
          displayExp="serviceTitle"
          valueExp="serviceUuid"
          isStandart
          :is-tagbox="true"
          :is-multiselect="true"
          :isDropdown="true"
          :disabled="isPublished"
          icon="plus"
          @input="updateLogchainServices"
        />
      </div>
      <ob-modal
        ref="services"
        :title="shoulderServicesTitle"
        title-second="Добавление"
        size="max"
        custom-class="logchain-item__services"
        :isAppendToBody="false"
      >
        <div class="logchain-item__services-categories">
          <ob-control-group
            :value="selectedModality"
            theme="light"
            :items="servicesItems"
            :key="modKey"
            @input="onModalityChange($event, selectedModality)"
          />
        </div>
        <div class="logchain-item__services-items">
          <tree-view
            v-for="item in tree"
            :key="item.uuid"
            :items="item"
            v-model="selectedTree"
            captionField="serviceTitle"
            childrenField="services"
            hasCheckbox
            showSelectedCounter
            unitField="serviceUnitTitle"
            showUnits
            counterUniqueField="serviceUuid"
            :isCheckboxesDisabled="isPublished"
          />
        </div>
        <div class="logchain-item__services-info">
          Будут добавлены все услуги, отмеченные галочками.
        </div>
        <div
          class="logchain-item__multi"
          v-if="
            logchain.mainData.resourceClassUuid ===
              'e7519b46-faf4-11e9-8f0b-362b9e155667' &&
              this.activeShoulder.ordinal == 2
          "
        >
          <h2>Мультистоповая логцепочка</h2>
          <ob-switcher
            labelRight="Мультистоповая логцепочка"
            v-model="isMulti"
          />
          <p v-if="!isMulti">
            Включите, если хотите создать мультистоповую логцепочку. Выбранные
            здесь услуги будут зафиксированы для всех плеч этой логцепочки
          </p>
          <ob-alert
            v-else
            text="Выбранные здесь услуги будут зафиксированы для всех плеч этой логцепочки"
            hideCloseButton
            theme="warning"
            icon="alert"
          />
        </div>
        <div slot="footer" class="modal-footer" v-if="!isPublished">
          <div class="ob-form-controls-container">
            <div class="form-controls__left">
              <ob-button
                :label="`Добавить услуги ${selectedTree.length}`"
                :disabled="isServicesFormDirty"
                @click="onSubmitServices"
              />
              <ob-button
                type="flat"
                label="Закрыть"
                @click="$refs.services.close()"
              />
            </div>
          </div>
        </div>
        <div slot="footer" class="modal-footer" v-else>
          <div class="ob-form-controls-container">
            <ob-button label="Закрыть" @click="$refs.services.close()" />
          </div>
        </div>
      </ob-modal>
    </div>
    <div class="logchain-item__error-container" v-if="errorMessage">
      <div class="logchain-item__error">
        <i class="icon alert"></i>
        {{ errorMessage }}
      </div>
    </div>
    <div class="logchain-item__actions">
      <div class="logchain-item__actions-left">
        <ob-button
          v-if="!isPublished"
          label="Опубликовать"
          :disabled="!logchain.mainData.isValid || isDirty"
          icon="route-unloading"
          type="primary-success"
          class="logchain-publish"
          @click="onPublish"
        />
        <ob-button
          v-if="!isPublished"
          label="Сохранить"
          type="outline"
          class="logchain-save"
          :disabled="isSaveReady"
          @click="onSave"
        />
        <ob-button
          v-if="isPublished"
          label="Отозвать"
          danger
          @click="onRevoke"
        />
        <ob-button label="Выйти" type="flat" @click="onExit" />
      </div>
      <div class="logchain-item__actions-right">
        <i class="icon copy-2 -blue-700"></i>
        <i
          :class="[
            'icon',
            'trash-sm -light-raspberry-red',
            isPublished ? 'disabled' : '',
          ]"
          @click="onDelete"
        ></i>
      </div>
    </div>
    <ob-modal
      ref="changeModality"
      title="Хотите изменить тип логцепочки на другую модальность?"
      size="medium"
      okText="Изменить"
      cancelText="Оставить"
      is-show-controls
      @submit="clearServices"
    >
      <p>Выбранные типы ТС будут отменены</p>
    </ob-modal>
    <ob-modal
      ref="publish"
      title="Опубликовать логцепочку?"
      size="medium"
      :is-show-controls="true"
      okText="Опубликовать"
      @submit="publish"
    >
      <p>
        Логцепочка будет опубликована, и с её помощью могут быть созданы новые
        заказы
      </p>
    </ob-modal>
    <ob-modal
      ref="exit"
      title="Сохранить логцепочку перед выходом?"
      size="medium"
    >
      <p>
        Вы можете сохранить логцепочку в Черновиках и в дальнейшем
        редактировать.
      </p>
      <div slot="footer" class="modal-footer">
        <ob-button label="Сохранить" @click="onSaveAndExit" />
        <ob-button type="flat" danger label="Не сохранять" @click="exit" />
        <ob-button
          type="outline"
          label="Вернуться к редактированию"
          @click="$refs.exit.close()"
        />
      </div>
    </ob-modal>
    <ob-modal
      ref="delete"
      title="Удалить черновик?"
      size="small"
      isError
      okText="Удалить"
      cancelText="Не удалять"
      is-show-controls
      @submit="deleteLogchain"
    >
      <p>Черновик логцепочки будет удалён без возможности восстановления</p>
    </ob-modal>
    <ob-modal
      ref="revoke"
      title="Отозвать логцепочку для внесения изменений?"
      size="small"
      ok-text="Отозвать"
      isError
      is-show-controls
      @submit="revokeLogchain"
    >
      <p>
        Цепочка вернётся в Черновики. Исполнители и Заказчики-исполнители не
        смогут использовать эту логцепочку, пока вы не опубликуете её обратно.
      </p>
    </ob-modal>
    <LogchainMapModal
      ref="mapModal"
      :data-source="{ address: {} }"
      :value="this.activeAddress.address"
      :locationsTypes="locationsTypes"
      :allowAddress="false"
      :direction="activeDirection"
      @input="setAddressFromModal"
    />
    <div class="save-shield" v-if="isSaving"></div>
  </single-pane>
</template>

<script>
import { uuid } from "vue-uuid";
import { compareValues } from "@/helpers";
import api from "@/api";
import SinglePane from "common-components/src/obComponents/obSinglePanels";
import Preloader from "@/services/Preloader/Preloader";
import ObTabs from "common-components/src/obComponents/obTabs";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import ObButton from "common-components/src/obComponents/obButton";
import treeView from "../../components/treeView";
import ObModal from "common-components/src/obComponents/obModal";
import ObControlGroup from "common-components/src/obComponents/obControlGroup";
import LogchainRouteCard from "./components/logchainRouteCard";
import LocationShoulder from "./components/locationShoulder";
import LogchainMapModal from "./components/logchainMapModal";
import obSelect from "common-components/src/obComponents/obSelect";
import ObSwitcher from "common-components/src/obComponents/obSwitcher";
import ObAlert from "common-components/src/obComponents/obAlert";

export default {
  name: "logchain-item",

  components: {
    SinglePane,
    Preloader,
    ObTabs,
    ObAddressInput,
    ObButton,
    treeView,
    ObModal,
    ObControlGroup,
    LogchainRouteCard,
    LocationShoulder,
    LogchainMapModal,
    obSelect,
    ObSwitcher,
    ObAlert,
  },

  categoriesMap: {
    "Целые машины": "truck",
    Контейнеры: "container",
    Вагоны: "train-sm",
  },

  resourcesMap: {
    "e7519b46-faf4-11e9-8f0b-362b9e155667": "CAR",
    "e7519ee8-faf4-11e9-8f0b-362b9e155667": "CONTAINER",
    "e7519d9e-faf4-11e9-8f0b-362b9e155667": "WAGON",
  },

  iconsMap: {
    "e7519b46-faf4-11e9-8f0b-362b9e155667": "truck",
    "e7519ee8-faf4-11e9-8f0b-362b9e155667": "container",
    "e7519d9e-faf4-11e9-8f0b-362b9e155667": "train-sm",
  },

  data() {
    return {
      isMulti: false,
      activeDirection: "from",
      errorMessage: null,
      isLoading: true,
      mainModality: "",
      backup: null,
      modKey: Date.parse(new Date()),
      newMod: "",
      services: [],
      pointServices: [],
      selectedModality: "",
      isSaving: false,
      activeAddress: {},
      activeShoulder: {},
      servicesCategory: "Целые машины",
      selectedTree: [],
      tree: [],
      currentTab: { uuid: this.$route.query.tab || "locations" },
      logchain: {},
      locationsTypes: [],
      logchainServices: [],
      logchainActiveServices: [],
      dropdownMenu: [
        {
          title: "Удалить",
          className: "color-error",
          href: "https://alfilatov.com/posts/run-chrome-without-cors/",
        },
        {
          title: "История",
          className: "color-success",
          to: { name: "data-grid" },
        },
        {
          title: "Редактирование",
          method: this.onClickEdit,
        },
      ],
    };
  },

  computed: {
    shoulderServicesTitle() {
      const prevPoint = this.activeShoulder?.ordinal === 2 ? this.startPoint.address.label : this.inBetweenPoints.find(point => point.ordinal === this.activeShoulder?.ordinal - 1)?.address.label;
      return `Услуги на плече ${prevPoint} → ${this.activeShoulder?.address?.label}`
    },
    isServicesFormDirty() {
      return (
        JSON.stringify(this.activeShoulder.services) ===
          JSON.stringify(this.selectedTree) &&
        this.logchain.mainData.isMultistop === this.isMulti
      );
    },

    backLink() {
      return this.logchain.mainData.status === "DRAFT"
        ? `/logchain-draft-list?tab=${
            this.$options.resourcesMap[this.logchain.mainData.resourceClassUuid]
          }`
        : `/logchain-list?tab=${
            this.$options.resourcesMap[this.logchain.mainData.resourceClassUuid]
          }`;
    },

    tabsItems() {
      return [
        {
          uuid: "locations",
          title: "Локации и услуги",
        },
        {
          uuid: "services",
          title: `Услуги на всей логцепочке ${
            this.logchain.services.length ? this.logchain.services.length : ""
          }`,
          isDisabled:
            this.logchain.mainData.resourceClassUuid !==
            "e7519ee8-faf4-11e9-8f0b-362b9e155667",
        },
        {
          uuid: "schedule",
          title: "Расписание",
          isDisabled: true,
        },
      ];
    },

    isDirty() {
      return this.backup !== JSON.stringify(this.logchain);
    },

    isSaved() {
      return !this.isDirty;
    },

    isPublished() {
      return (
        this.$route.params.id !== "new-logchain" &&
        this.logchain.mainData.status !== "DRAFT"
      );
    },

    serviceCategoryIcon() {
      return this.$options.categoriesMap[this.servicesCategory];
    },

    startPoint() {
      return this.logchain.points && this.logchain.points.length
        ? this.logchain.points.find((point) => point.ordinal === 1)
        : "";
    },

    endPoint() {
      return this.logchain.points && this.logchain.points.length
        ? this.logchain.points[this.logchain.points.length - 1]
        : "";
    },

    inBetweenPoints() {
      return this.logchain.points.slice(1, -1);
    },

    servicePoints() {
      return [...this.inBetweenPoints, this.endPoint];
    },

    servicesCount() {
      return this.activeShoulder.services?.length
        ? `(${this.activeShoulder.services.length})`
        : "";
    },

    totalServices() {
      let leafs = 0;
      const searchTree = (items) => {
        if (!!items.services && items.services.length > 0) {
          items.services.forEach((item) => searchTree(item));
        } else {
          leafs++;
        }
      };

      this.tree.forEach((item) => searchTree(item));
      return leafs;
    },

    servicesItems() {
      if (this.services) {
        return [
          {
            label: `Целые машины ${
              this.activeShoulder.resourceClassUuid ===
              "e7519b46-faf4-11e9-8f0b-362b9e155667"
                ? this.activeShoulder.services.length
                : "0"
            }/${this.getServiceLength(
              this.services["e7519b46-faf4-11e9-8f0b-362b9e155667"]
            )}`,
            value: "e7519b46-faf4-11e9-8f0b-362b9e155667",
            icon: "truck",
            disabled: this.isServiceCarDisabled,
          },
          {
            label: `Вагоны ${
              this.activeShoulder.resourceClassUuid ===
              "e7519d9e-faf4-11e9-8f0b-362b9e155667"
                ? this.activeShoulder.services.length
                : "0"
            }/ ${this.getServiceLength(
              this.services["e7519d9e-faf4-11e9-8f0b-362b9e155667"]
            )}`,
            value: "e7519d9e-faf4-11e9-8f0b-362b9e155667",
            icon: "train-sm",
            disabled: this.isServiceWagonsDisabled,
          },
        ];
      }
      return [];
    },

    isServiceCarDisabled() {
      if (
        this.logchain.mainData.resourceClassUuid ===
        "e7519ee8-faf4-11e9-8f0b-362b9e155667"
      )
        return false;

      return (
        (this.activeShoulder.isMain &&
          this.logchain.mainData.resourceClassUuid !==
            "e7519b46-faf4-11e9-8f0b-362b9e155667") ||
        this.isPublished
      );
    },

    isServiceWagonsDisabled() {
      if (
        this.logchain.mainData.resourceClassUuid ===
        "e7519ee8-faf4-11e9-8f0b-362b9e155667"
      )
        return false;

      return (
        (this.activeShoulder.isMain &&
          this.logchain.mainData.resourceClassUuid !==
            "e7519d9e-faf4-11e9-8f0b-362b9e155667") ||
        this.isPublished
      );
    },

    isSaveReady() {
      return (
        !this.isDirty ||
        this.logchain.points.some(
          (point) => point.address.label === "Новая локация"
        ) ||
        !this.startPoint.address.label ||
        !this.endPoint.address.label
      );
    },

    newOrdinalNumber() {
      const ordinals = this.logchain.points.map((point) => point.ordinal);
      return Math.max(...ordinals) + 1;
    },
  },

  watch: {
    selectedModality(newVal) {
      this.activeShoulder.resourceClassUuid = newVal;
      this.tree = this.services[newVal];
      // this.loadServices(newVal);
    },

    currentTab(newVal) {
      if (newVal.uuid === "services") {
        api.logchain.getAllLogchainServices().then((res) => {
          res.map(
            (item) =>
              (item.serviceUnitUuid = "1469b24c-be8c-4fb5-8e8c-2652f4d4f118")
          );
          this.logchainServices = res;
        });
      }
    },

    logchain: {
      handler(newVal) {
        this.errorMessage = null;
        this.isMulti = newVal.mainData.isMultistop;
      },
      deep: true,
    },
  },

  async created() {
    const id = this.$route.params.id;

    if (id === "new-logchain") {
      await this.getServices();
      await this.getLogchainPointServices();
      this.initEmptyLogchain();
    } else {
      await this.loadLogchain(id);
      // await this.getServices();
      if (this.logchain.services.length) {
        this.logchainActiveServices = this.logchain.services.map(
          (item) => item.uuid
        );
      }
    }
    this.backup = JSON.stringify(this.logchain);
    this.isLoading = !!this.services.length;
  },

  mounted() {
    api.locations
      .getLocationTypes()
      .then((res) => {
        this.locationsTypes = res.data.content;
      })
      .catch((e) => {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных",
        });
      });
  },

  methods: {
    updateLogchainServices() {
      this.logchain.services = this.logchainActiveServices.reduce(
        (acc, item) => {
          const target = this.logchainServices.find(
            (service) => service.serviceUuid === item
          );
          acc.push({
            uuid: target.serviceUuid,
            serviceUnitUuid: "1469b24c-be8c-4fb5-8e8c-2652f4d4f118",
          });
          return acc;
        },
        []
      );
    },

    onModalityChange($event, oldVal) {
      this.selectedModality = oldVal;
      this.modKey = Date.parse(new Date());
      this.newMod = $event;
      this.$refs.changeModality.open();
    },

    clearServices() {
      this.selectedTree = [];
      this.activeShoulder.services = [];
      this.selectedModality = this.newMod;
      if (this.selectedModality === "e7519d9e-faf4-11e9-8f0b-362b9e155667") {
        this.selectedTree = this.services[
          "e7519d9e-faf4-11e9-8f0b-362b9e155667"
        ].reduce((acc, item) => {
          if (
            item.serviceTitle === "Перевозка ЖД вагоном" ||
            item.serviceTitle === "Оплата провозного тарифа"
          )
            acc.push(...item.services.map((service) => service));
          return acc;
        }, []);
      }
      this.$refs.changeModality.close();
    },

    async getServices() {
      let cars = "";
      let wagons = "";
      const type = this.$route.query.resourceClassUuid || this.mainModality;
      if (type === "e7519ee8-faf4-11e9-8f0b-362b9e155667") {
        cars = await api.logchain.getLogchainContainerServices(
          "e7519b46-faf4-11e9-8f0b-362b9e155667"
        );
        wagons = await api.logchain.getLogchainContainerServices(
          "e7519d9e-faf4-11e9-8f0b-362b9e155667"
        );
      } else {
        cars = await api.logchain.getLogchainServices(
          "e7519b46-faf4-11e9-8f0b-362b9e155667"
        );
        wagons = await api.logchain.getLogchainServices(
          "e7519d9e-faf4-11e9-8f0b-362b9e155667"
        );
      }

      cars.forEach((item) => {
        item.serviceTitle = item.serviceTypeTitle;
      });
      wagons.forEach((item) => {
        item.serviceTitle = item.serviceTypeTitle;
      });
      this.services = {
        "e7519b46-faf4-11e9-8f0b-362b9e155667": [...cars],
        "e7519d9e-faf4-11e9-8f0b-362b9e155667": [...wagons],
      };
    },
    async getLogchainPointServices() {
      try {
        const res = await api.logchain.getLogchainPointServices();
        this.pointServices = res.reduce((acc, item) => {
          acc.push({
            uuid: item.serviceUuid,
            title: item.serviceTitle,
            html: `<div class="point-services">${item.serviceTitle}<span>${item.serviceUnitTitle}</span></div>`,
            serviceUnitTitle: item.serviceUnitTitle,
            serviceUnitUuid: item.serviceUnitUuid,
          });
          return acc;
        }, []);
      } catch (e) {
        console.error(e);
      }
    },

    getServiceLength(service) {
      let leafs = 0;
      const searchTree = (items) => {
        if (!!items.services && items.services.length > 0) {
          items.services.forEach((item) => searchTree(item));
        } else {
          leafs++;
        }
      };

      service.forEach((item) => searchTree(item));
      return leafs;
    },

    async loadServices(uuid) {
      const data = await api.logchain.getLogchainServices(uuid);
      data.forEach((item) => {
        item.serviceTitle = item.serviceTypeTitle;
      });
      this.tree = data;
    },

    onOpenMapModal(point, direction) {
      this.activeDirection = direction;
      this.activeAddress = this.logchain.points.find(
        (item) => item.ordinal === point.ordinal
      );
      this.$nextTick(() => {
        this.$refs.mapModal.open();
      });
    },

    setAddressFromModal($event) {
      this.activeAddress.address = $event.payload;
      this.activeAddress.locationTitle = $event.payload.label;
      this.activeAddress.locationTypeIcon = $event.payload.icon.toUpperCase();
      this.activeAddress.locationUuid = $event.payload.uuid;
    },

    setInBetweenAddress($event, point) {
      const target = this.logchain.points.find(
        (item) => item.ordinal === point.ordinal
      );
      target.address = $event;
      target.locationTitle = $event.label;
      target.locationTypeIcon = $event.icon.toUpperCase();
      target.locationUuid = $event.locationUuid;
    },

    addPoint(ordinal) {
      const nextPoint = this.logchain.points[ordinal];

      const newPoint = {
        uuid: uuid.v4(),
        ordinal: ordinal + 1,
        resourceClassUuid: this.logchain.mainData.resourceClassUuid === 'e7519ee8-faf4-11e9-8f0b-362b9e155667' ? 'e7519b46-faf4-11e9-8f0b-362b9e155667' : this.logchain.mainData.resourceClassUuid ,
        isMain: nextPoint.isMain ? true : false,
        locationTitle: "Новая локация",
        locationTypeIcon: "question",
        locationUuid: "",
        services: [...nextPoint.services],
        servicesOnPoint: [],
        address: {
          isValid: true,
          label: "",
          coordinates: {},
        },
      };

      nextPoint.services = [];

      if (nextPoint.isMain) {
        nextPoint.isMain = false;
      }

      const temp = this.logchain.points.filter(
        (point) => point.ordinal >= ordinal + 1
      );
      temp.forEach((item) => (item.ordinal += 1));
      this.logchain.points.splice(ordinal, 0, newPoint);
    },

    removePoint(ordinal) {
      this.logchain.points = this.logchain.points.filter(
        (point) => point.ordinal !== ordinal
      );
      const target = this.logchain.points.filter(
        (point) => point.ordinal > ordinal
      );
      target.forEach((item) => (item.ordinal -= 1));
    },

    makeActivePoint(ordinal) {
      this.logchain.points.forEach((item) => (item.isMain = false));
      const target = this.logchain.points.find(
        (item) => item.ordinal === ordinal
      );
      target.isMain = true;
    },

    addServices(ordinal) {
      if (ordinal === 1 && this.inBetweenPoints.length) {
        this.activeShoulder = this.logchain.points.find(
          (point) => point.ordinal === 2
        );
      } else if (ordinal === 1 && !this.inBetweenPoints.length) {
        this.activeShoulder = this.endPoint;
      } else {
        const target = this.inBetweenPoints.find(
          (point) => point.ordinal === ordinal
        );
        if (target) {
          this.activeShoulder = target;
        } else {
          this.activeShoulder = this.endPoint;
        }
      }

      this.selectedTree = this.activeShoulder.services;
      this.selectedModality = this.activeShoulder.resourceClassUuid;
      this.tree = this.services[this.selectedModality];
      if (
        this.selectedModality === "e7519d9e-faf4-11e9-8f0b-362b9e155667" &&
        this.activeShoulder.services.length === 0
      ) {
        this.selectedTree = this.services[
          "e7519d9e-faf4-11e9-8f0b-362b9e155667"
        ].reduce((acc, item) => {
          if (
            item.serviceTitle === "Перевозка ЖД вагоном" ||
            item.serviceTitle === "Оплата провозного тарифа"
          )
            acc.push(...item.services.map((service) => service));
          return acc;
        }, []);
      }
      this.$refs.services.open();
    },

    isEmptyObj(obj) {
      for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
          return false;
        }
      }
      return true;
    },

    async loadLogchain(id) {
      const res = await api.logchain.getLogchain(id);
      this.mainModality = res.mainData.resourceClassUuid;
      await this.getServices();
      await this.getLogchainPointServices();
      res.points.sort(compareValues("ordinal", "asc"));
      res.points.forEach((item, index) => {
        item.address = {
          label: item.locationTitle,
          coordinates: {},
          icon: item.locationTypeIcon.toLowerCase() || "pin",
        };

        item.services.forEach((service, index1) => {
          for (let i in this.services) {
            this.services[i].forEach((tree) => {
              const test = tree.services.find(
                (item) => item.serviceUuid === service.uuid
              );
              if (test) {
                res.points[index].services[index1] = { ...test };
              }
            });
          }
        });
      });
      this.logchain = res;
      // if (!res.mainData.resourceClassUuid) this.logchain.mainData.resourceClassUuid = "e7519b46-faf4-11e9-8f0b-362b9e155667";
    },

    initEmptyLogchain() {
      this.logchain = {
        mainData: {
          uuid: uuid.v4(),
          number: "",
          status: "DRAFT",
          resourceClassUuid: this.$route.query.resourceClassUuid,
          isManual: true,
          isValid: false,
          isMultistop: false,
        },
        services: [],
        points: [
          {
            uuid: uuid.v4(),
            ordinal: 1,
            resourceClassUuid: null,
            isMain: false,
            services: [],
            servicesOnPoint: [],
            locationUuid: "",
            locationTitle: "",
            locationTypeIcon: "",
            address: {
              label: "",
              coordinates: {},
            },
          },
          {
            uuid: uuid.v4(),
            ordinal: 2,
            resourceClassUuid:
              this.$route.query.resourceClassUuid ===
              "e7519ee8-faf4-11e9-8f0b-362b9e155667"
                ? "e7519b46-faf4-11e9-8f0b-362b9e155667"
                : this.$route.query.resourceClassUuid,
            isMain: true,
            services: [],
            servicesOnPoint: [],
            locationUuid: "",
            locationTitle: "",
            locationTypeIcon: "",
            address: {
              label: "",
              coordinates: {},
            },
          },
        ],
      };
    },

    setAddressFrom($event) {
      this.logchain.points[0].address = $event;
      this.logchain.points[0].locationTitle = $event.label;
      this.logchain.points[0].locationTypeIcon = $event.icon.toUpperCase();
      this.logchain.points[0].locationUuid = $event.locationUuid;
      if (!$event.icon) {
        this.logchain.points[0].address.icon = "pin";
      }
    },

    setAddressTo($event) {
      this.logchain.points[this.logchain.points.length - 1].address = $event;
      this.logchain.points[this.logchain.points.length - 1].locationTitle =
        $event.label;
      this.logchain.points[
        this.logchain.points.length - 1
      ].locationTypeIcon = $event.icon.toUpperCase();
      this.logchain.points[this.logchain.points.length - 1].locationUuid =
        $event.locationUuid;
      if (!$event.icon) {
        this.logchain.points[this.logchain.points.length - 1].address.icon =
          "pin";
      }
    },

    onSubmitServices() {
      this.activeShoulder.services = [...this.selectedTree];
      this.logchain.mainData.isMultistop = this.isMulti;
      if (this.isMulti && this.inBetweenPoints.length) {
        for (let i = this.inBetweenPoints.length - 1; i > 1; i -= 1) {
          this.inBetweenPoints[i].services = [];
        }
        this.endPoint.services = [];
      }
      if (!this.isMulti && this.logchain.mainData.resourceClassUuid === 'e7519b46-faf4-11e9-8f0b-362b9e155667') {
        this.logchain.points = this.logchain.points.filter(point => point.ordinal === 1 || point.ordinal === this.logchain.points.length);
        const lastPoint = this.logchain.points[this.logchain.points.length - 1];
        lastPoint.ordinal = 2;
      }
      this.$refs.services.close();
    },

    onSubmitPointServices($event, target) {
      if (target === "start") {
        this.activeShoulder = this.startPoint;
      } else if (target === "end") {
        this.activeShoulder = this.endPoint;
      } else {
        const point = this.logchain.points.find(
          (item) => item.ordinal === target.ordinal
        );
        this.activeShoulder = point;
      }

      this.activeShoulder.servicesOnPoint = [
        ...$event.map((item) => {
          const point = this.pointServices.find(
            (service) => service.uuid === item
          );
          return {
            uuid: item,
            serviceUnitUuid: point.serviceUnitUuid,
          };
        }),
      ];
    },

    onPublish() {
      this.$refs.publish.open();
    },

    onExit() {
      if (this.isSaved) {
        this.$router.push(this.backLink);
        return;
      }
      this.$refs.exit.open();
    },

    async onSave() {
      this.isSaving = true;
      let notificationId = new Date().getTime() + "save";
      this.logchain.points.forEach((point) => {
        point.services?.forEach((service) => {
          service.uuid = service.serviceUuid;
        });
      });

      try {
        this.$notification({
          type: "system_notification_in_load",
          message: "Сохранение",
          id: notificationId,
        });
        await api.logchain.saveLogchain(
          this.logchain.mainData.uuid,
          this.logchain
        );
        this.$router.push(`/logchain-item/${this.logchain.mainData.uuid}`);
        await this.loadLogchain(this.logchain.mainData.uuid);
        this.backup = JSON.stringify(this.logchain);
        if (this.logchain.services.length) {
          this.logchainActiveServices = this.logchain.services.map(
            (item) => item.uuid
          );
        }
        this.$notification({
          type: "system_notification_success",
          message: "Сохранено",
        });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Не сохранено",
        });
      } finally {
        this.$notification({ event: "close", id: notificationId });
        this.isSaving = false;
      }
    },

    async onSaveAndExit() {
      this.logchain.points.forEach((point) => {
        point.services?.forEach((service) => {
          service.uuid = service.serviceUuid;
        });
      });
      try {
        await api.logchain.saveLogchain(
          this.logchain.mainData.uuid,
          this.logchain
        );
        this.$router.push(`/logchain-draft-list`);
        this.$notification({
          type: "snackbars",
          message: `Черновик ${this.logchain.mainData.number} сохранён`,
        });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Не сохранено",
        });
      }
    },

    onDelete() {
      this.$refs.delete.open();
    },

    onRevoke() {
      this.$refs.revoke.open();
    },

    exit() {
      this.$router.push("/logchain-draft-list");
      this.$notification({
        type: "snackbars",
        message: `Редактирование черновика ${this.logchain.mainData.number} завершено`,
      });
    },

    async publish() {
      this.logchain.points.forEach((point) => {
        point.services?.forEach((service) => {
          service.uuid = service.serviceUuid;
        });
      });
      try {
        const res = await api.logchain.publishLogchain(
          this.logchain.mainData.uuid
        );
        this.$refs.publish.close();
        if (!res.result) {
          this.errorMessage = res.errors[0];
        } else {
          this.$router.push(
            `/logchain-list?tab=${
              this.$options.resourcesMap[
                this.logchain.mainData.resourceClassUuid
              ]
            }`
          );
        }
      } catch (e) {
        console.error(e);
      }
    },

    async deleteLogchain() {
      try {
        await api.logchain.deleteLogchain(this.logchain.mainData.uuid);
        this.$refs.delete.close();
        this.$router.push("/logchain-draft-list");
        this.$notification({
          type: "snackbars",
          message: `Черновик ${this.logchain.mainData.number} удалён`,
        });
      } catch (error) {
        console.error(error);
      }
    },

    async revokeLogchain() {
      try {
        await api.logchain.revokeLogchain(this.logchain.mainData.uuid);
        this.$refs.revoke.close();
        this.loadLogchain(this.logchain.mainData.uuid);
        this.$notification({
          type: "snackbars",
          message: "Логцепочка отозвана в Черновики для внесения изменений",
        });
      } catch (error) {
        console.error(error);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.logchain-item {
  position: relative;
  z-index: 1;
  display: flex;
  flex-direction: column;
}

.logchain-item__header {
  padding: 13px 22px;
  display: flex;
  align-items: flex-start;
  @include font-mixin(16px, 20px, 400, $color-blue-navy-blue, 0.2px);

  span {
    display: flex;
    flex-shrink: 0;
    align-items: center;
    cursor: pointer;

    i {
      position: relative;
      margin-right: 12px;
    }
  }
}

.logchain-item__summary {
  margin-left: 23px;
  display: flex;
  align-items: flex-start;
  color: $color-text-base;

  p {
    flex-shrink: 0;
  }

  span {
    margin-left: 14px;
    @include font-mixin(10px, 20px, 400, $gray-slate, 0.4px, uppercase);
  }
}

.logchain-item__summary-route {
  margin-left: 14px;
  display: flex;
  flex-wrap: wrap;
  align-items: center;
  color: $color-text-base;

  & > div {
    display: flex;
    align-items: center;

    &:not(:last-child) {
      margin-right: 5px;
    }
  }

  i {
    margin-right: 5px;
    color: $color-blue-smalt;
  }

  .main {
    color: $color-green-light;
  }
}

.logchain-item__tabs {
  padding: 20px 22px 0 20px;
  position: relative;
  z-index: 1;
  box-shadow: 0px 2px 10px rgba(0, 75, 200, 0.15);
}

.logchain-item__constructor-wrapper {
  flex-grow: 1;
  padding-bottom: 33px;
}

.logchain-item-constructor {
  position: relative;
  padding: 22px;

  &:before {
    content: "";
    position: absolute;
    top: 25px;
    left: 40px;
    height: calc(100% - 50px);
    border-left: 2px dotted $cornflower-craiola;
    z-index: -1;
  }
}

.logchain-item-constructor__item {
  position: relative;
  padding: 18px 18px 20px;
  box-shadow: 0px 4px 16px rgba(0, 75, 200, 0.2);
  border-radius: 4px;
  background: #fff;

  & + & {
    margin-top: 63px;
  }
}

.logchain-title {
  margin-bottom: 13px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  @include font-mixin(20px, 28px, 400, $color-text-base, 0.4px);

  &--new {
    color: $color-error;
    font-weight: 700;
  }

  i {
    font-size: 14px;
    color: $color-grey-span;
    cursor: pointer;
  }
}

.add-location {
  margin-top: 32px;
  margin-bottom: 40px;
  padding-left: 54px;

  i {
    color: $color-error;
  }
}

.logchain-item__actions {
  display: flex;
  justify-content: space-between;
  padding: 0 20px 20px;

  i {
    cursor: pointer;
  }
}

.logchain-item__actions-left,
.logchain-item__actions-right {
  display: flex;
  align-items: center;
}

.logchain-item__actions-right i:first-child {
  margin-right: 25px;
}

.logchain-publish {
  width: 195px;
  margin-right: 10px;
}

.logchain-save {
  width: 154px;
  margin-right: 20px;
}

.logchain-item__services-categories {
  margin-bottom: 28px;
}

.logchain-item__services-info {
  margin-top: 29px;
  color: $gray-slate;
}

.logchain-item__card {
  position: relative;
  z-index: 2;
  padding: 22px 22px 0;
  background-color: #fff;
}

i.disabled {
  color: $color-grey-span;
  pointer-events: none;

  &:before {
    color: $color-grey-span;
  }
}

.logchain-item-constructor__item-services {
  margin-top: 20px;
}

.logchain-item__error-container {
  padding: 0 22px;
}

.logchain-item__error {
  margin-bottom: 40px;
  padding: 20px;
  display: flex;
  align-items: center;
  background-color: rgba(230, 45, 59, 0.1);
  @include font-mixin(14px, 20px, 400, $color-text-base, 0.4px);

  i {
    margin-right: 20px;
    color: $color-error;
    font-size: 24px;
  }
}

.logchain-item__multi {
  margin-top: 30px;

  h2 {
    margin-bottom: 20px;
    @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);
  }

  p {
    margin-top: 10px;
    padding-left: 36px;
  }

  .ob-alert-container {
    margin-top: 20px;
  }
}
</style>

<style lang="scss">
// .logchain-item__services.logchain-item__services.logchain-item__services.logchain-item__services.logchain-item__services.logchain-item__services {
//   width: 100% !important;
//   max-width: none !important;
//   height: 100%;
//   margin: 0 !important;
//   border-radius: 0;
//   overflow-y: auto;
// }

.save-shield {
  position: fixed;
  width: 100%;
  height: 100%;
  z-index: 1000;
  top: 0;
  left: 0;
  background-color: rgba(255, 255, 255, 0.5);
}

.logchain-item-services {
  position: relative;
  padding: 50px 22px 22px;
}

.point-services-wrapper {
  .ob-selector__list-item-title-wrapper,
  .ob-selector__list-item-html {
    width: 100%;
  }

  .ob-selector__list-item-html + .ob-selector__list-item-text {
    display: none;
  }

  .point-services {
    width: 100%;
    display: flex;
    justify-content: space-between;
    font-family: "Roboto", sans-serif;
    font-size: 16px;
    font-weight: 400;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: #191e32;
    text-transform: none;
    text-decoration: none;
  }
}
</style>
